<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2010 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| xhtml mobile mod by theNoam
| http://www.thenoam.com/
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------+*/
require_once("wap-maincore.php");
// locale begin
if (file_exists(WAP."locale/".$settings['locale'].".php")) {
	include WAP."locale/".$settings['locale'].".php";
} else {
	include WAP."locale/English.php";
}
// locale end

echo("<?xml version=\"1.0\" encoding=\"".$locale['charset']."\"?>\n");
echo("<!DOCTYPE html PUBLIC \"-//WAPFORUM//DTD XHTML Mobile 1.0//EN\""
." \"http://www.wapforum.org/DTD/xhtml-mobile10.dtd\">\n");
echo "
<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang='".$locale['wap004']."'>\n
<head>\n
    <title>".$locale['wap001']."</title>\n
	<meta http-equiv='Content-Type' content='text/html; charset=".$locale['charset']."'/>\n
    <link href='style.css' rel='stylesheet' type='text/css'/>\n
</head>\n";
echo "
<body>\n
<div class='dir'>\n
<table class='wide'>\n
<tr><td><img src='images/banner_wap.gif' class='displayed' alt='".$locale['wap002']."'/></td></tr>\n
<tr><td><div class='center'>".$locale['wap022']."</div></td></tr>\n";

if (!isset($_GET['article_id']) || !isnum($_GET['article_id'])) {redirect("index.php");}
if ($_GET["article_id"] > 0) {
$article_id = $_GET["article_id"];
} else {redirect("index.php");}

$result = dbquery("SELECT * FROM ".$db_prefix."articles WHERE article_id='".$article_id."'");

if (dbrows($result) != 0) {
$data = dbarray($result);
if ( $data['article_article'] != "") {
$description = stripslashes(nl2br($data['article_article']));
} else {
$description = stripslashes(nl2br($data['article_snippet']));
}
// Add allowable HTML tags below, all others will be stripped
	$description = strip_tags($description, "<p></p><br><br/><br />");
// Parse bbcode into regular text begin
	$description = preg_replace('#\<p\>(.*?)\</p\>#si', '\1'.'<br />', $description);
	$description = preg_replace('#(\<br\>([\r\n]*))+#si', '<br />', $description);
	$description = preg_replace('#(\<br/\>([\r\n]*))+#si', '<br />', $description);
	$description = preg_replace('#(\<br /\>([\r\n]*))+#si', '<br />', $description);
	$description = preg_replace('#\[b\](.*?)\[/b\]#si', '\1', $description);
	$description = preg_replace('#\[i\](.*?)\[/i\]#si', '\1', $description);
	$description = preg_replace('#\[u\](.*?)\[/u\]#si', '\1', $description);
	$description = preg_replace('#\[size=(.*?)\](.*?)\[/size\]#si', '\2', $description);
	$description = preg_replace('#\[center\](.*?)\[/center\]#si', '\1', $description);
	$description = preg_replace('#\[small\](.*?)\[/small\]#si', '\1', $description);
	$description = preg_replace('#\[color=(black|blue|brown|cyan|gray|green|lime|maroon|navy|olive|orange|purple|red|silver|violet|white|yellow)\](.*?)\[/color\]#si', '\2', $description);
	$description = preg_replace('#\[color=(.*?)\](.*?)\[/color\]#si', '\2', $description);
	$description = preg_replace('#\[flash width=([0-9]*?) height=([0-9]*?)\]([^\s\'\";:\+]*?)(\.swf)\[/flash\]#si', ' ', $description);
	$description = preg_replace('#\[youtube\](.*?)\[/youtube\]#si', 'MOVIE ', $description);
	$description = preg_replace('#\[blink\](.*?)\[/blink\]#si', '\1', $description);
	$description = preg_replace('#\[cimg\]((http|ftp|https|ftps)://)(.*?)(\.(jpg|jpeg|gif|png|JPG|JPEG|GIF|PNG))\[/cimg\]#si', 'PIC ', $description);
	$description = preg_replace('#\[img\]((http|ftp|https|ftps)://)(.*?)(\.(jpg|jpeg|gif|png|JPG|JPEG|GIF|PNG))\[/img\]#si', 'PIC ',$description);
	$description = preg_replace('#(PIC (\<br /\>)*)+#si', 'PIC ', $description);
	$description = preg_replace('#\[url\]([\r\n]*)([^\s\'\";\+]*?)([\r\n]*)\[/url\]#si', 'URL ', $description);
	$description = preg_replace('#\[url=([\r\n]*)(http://|ftp://|https://|ftps://)([^\s\'\";\+]*?)\](.*?)([\r\n]*)\[/url\]#si', 'URL ', $description);
	$description = preg_replace('#\[url=([\r\n]*)([^\s\'\";\+]*?)\](.*?)([\r\n]*)\[/url\]#si', 'URL', $description);
	$description = preg_replace('#\[mail\]([\r\n]*)([^\s\'\";:\+]*?)([\r\n]*)\[/mail\]#si', 'MAIL', $description);
	$description = preg_replace('#\[mail=([\r\n]*)([^\s\'\";:\+]*?)\](.*?)([\r\n]*)\[/mail\]#si', 'MAIL', $description);
// start addition
	$description = preg_replace('@(https?://([-\w\.]+)+(:\d+)?(/([\w/_\.]*(\?\S+)?)?)?)@i', 'URL ', $description);
	$description = preg_replace('@(www\.(:\d+)?(/([\w/_\.]*(\?\S+)?)?)?)@i', 'URL ', $description);
	$description = preg_replace('@\[code\](.*?)\[/code\]@si', 'CODE ', $description);
// end addition	
	$qcount = substr_count($description, "[quote]"); $ccount = substr_count($description, "[code]");
	for ($i=0;$i < $qcount;$i++) $description = preg_replace('#\[quote\](.*?)\[/quote\]#si', '\2', $description);
	for ($i=0;$i < $ccount;$i++) $description = preg_replace('#\[code\](.*?)\[/code\]#si', '\2', $description);
// Parse bbcode into regular text end

$itemsubject = trimlink($data['article_subject'], 99);
echo "<tr><td class='blue3'>".$itemsubject."</td></tr>\n";
echo "<tr><td class='blue2'>".$description."</td></tr>\n";
} 
echo "
</table>\n
<p class='center'>\n
<a href='wap-articles.php' class='black'>".$locale['wap032']."</a><br />\n
<a href='index.php' class='black'>".$locale['wap010']."</a>\n
</p>\n
</div>\n
</body>\n
</html>\n";
?>