<?php
require_once "wap-maincore.php";
// locale begin
if (file_exists(WAP."locale/".$settings['locale'].".php")) {
	include WAP."locale/".$settings['locale'].".php";
} else {
	include WAP."locale/English.php";
}
// locale end

$time1 = time();
$time2 = time();
$settingsoffset = $settings['timeoffset'];

echo "<?xml version=\"1.0\" encoding=\"".$locale['charset']."\"?>\n";
echo "<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\" xmlns:mobile=\"http://www.google.com/schemas/sitemap-mobile/1.0\">\n\n";

echo "
<!-- home page -->\n
<url>\n
<loc>".$settings['siteurl']."wap2/index.php</loc>\n
<priority>1.0</priority>\n
<lastmod>".strtime($time1,$settingsoffset)."</lastmod>\n
<changefreq>monthly</changefreq>\n
<mobile:mobile/>\n
</url>\n\n

<!-- news page -->\n
<url>\n
<loc>".$settings['siteurl']."wap2/wap-news.php</loc>\n
<priority>1.0</priority>\n
<lastmod>".strtime($time1,$settingsoffset)."</lastmod>\n
<changefreq>monthly</changefreq>\n
<mobile:mobile/>\n
</url>\n\n

<!-- articles page -->\n
<url>\n
<loc>".$settings['siteurl']."wap2/wap-articles.php</loc> \n
<priority>1.0</priority>\n
<lastmod>".strtime($time1,$settingsoffset)."</lastmod>\n
<changefreq>monthly</changefreq>\n
<mobile:mobile/>\n
</url>\n\n

<!-- forums page -->\n
<url>\n
<loc>".$settings['siteurl']."wap2/wap-forums.php</loc>\n
<priority>1.0</priority>\n
<lastmod>".strtime($time1,$settingsoffset)."</lastmod>\n
<changefreq>daily</changefreq>\n
<mobile:mobile/>\n
</url>\n\n

<!-- shout box page -->\n
<url>\n
<loc>".$settings['siteurl']."wap2/wap-shouts.php</loc>\n
<priority>1.0</priority>\n
<lastmod>".strtime($time1,$settingsoffset)."</lastmod>\n
<changefreq>monthly</changefreq>\n
<mobile:mobile/>\n
</url>\n\n

<!-- random gallery picture page -->\n
<url>\n
<loc>".$settings['siteurl']."wap2/wap-gallery.php</loc>\n
<priority>1.0</priority>\n
<lastmod>".strtime($time1,$settingsoffset)."</lastmod>\n
<changefreq>monthly</changefreq>\n
<mobile:mobile/>\n
</url>\n\n

<!-- last gallery picture page -->\n
<url>\n
<loc>".$settings['siteurl']."wap2/wap-gallery-n.php</loc>\n
<priority>1.0</priority>\n
<lastmod>".strtime($time1,$settingsoffset)."</lastmod>\n
<changefreq>monthly</changefreq>\n
<mobile:mobile/>\n
</url>\n\n
";

$result = dbquery("SELECT * FROM ".$db_prefix."articles
					INNER JOIN ".$db_prefix."article_cats
                    ON article_cat_id = article_cat
					WHERE article_cat_access='0'
					ORDER BY article_datestamp DESC LIMIT 0,500");
$rows = dbrows($result);
if ($rows!=0) {
	echo "<!-- articles -->\n";
	while ($data = dbarray($result)) {
		echo "<url>\n
<loc>".$settings['siteurl']."wap2/wap-articles-e.php?article_id=".$data['article_id']."</loc>\n
<priority>0.2</priority>\n
<lastmod>".strtime($data['article_datestamp'],$settingsoffset)."</lastmod>\n
<changefreq>monthly</changefreq>\n
<mobile:mobile/>\n
</url>\n";
	}
	echo "\n";
}

$result = dbquery("SELECT * FROM ".$db_prefix."news
					WHERE news_visibility='0'
                    ORDER BY news_datestamp DESC LIMIT 0,500");
$rows = dbrows($result);
if ($rows!=0) {
	echo "<!-- news -->\n";
	while ($data = dbarray($result)) {
		echo "<url>\n
<loc>".$settings['siteurl']."wap2/wap-news-e.php?news_id=".$data['news_id']."</loc>\n
<priority>0.1</priority>\n
<lastmod>".strtime($data['news_datestamp'],$settingsoffset)."</lastmod>\n
<changefreq>monthly</changefreq>\n
<mobile:mobile/>\n
</url>\n";
	}
	echo "\n";
}

$result = dbquery("SELECT * FROM ".$db_prefix."threads
	                ORDER BY thread_lastpost DESC LIMIT 0,1000");
$rows = dbrows($result);
if ($rows!=0) {
	echo "<!-- forum threads -->\n";
	echo "\n";
	while ($data = dbarray($result)) {
		$foid = $data['forum_id'];	
		$result2 = dbquery("SELECT * FROM ".$db_prefix."forums WHERE forum_id='".$foid."'");
		if (dbrows($result2)) {
		$fdata = dbarray($result2);
		$fcgroup = $fdata['forum_access'];
		if ( $fcgroup == "0" ) {
		echo "<url>\n
<loc>".$settings['siteurl']."wap2/wap-forums-e.php?thread_id=".$data['thread_id']."</loc>\n
<priority>0.2</priority>\n
<lastmod>".strtime($time2,$settingsoffset)."</lastmod>\n
<changefreq>daily</changefreq>\n
<mobile:mobile/>\n
</url>\n";
	}}}
	echo "\n";
}
echo "</urlset>";


function strtime($time,$settingsoff) {
	$str_date = gmdate("Y-m-d", $time);
	$str_time = gmdate("H:i:s", $time);
	$intvaloffset = intval($settingsoff);

	if ( $intvaloffset == $settingsoff )
	{
		$dotoffset = "00"; 
	} else {
		$dotoffset = "30";
	}
	
	if (strlen($intvaloffset) < 2) 
	{ 
		$timeoffset = "0".$intvaloffset;
	} else {
		$timeoffset = $intvaloffset;
	}
		
	$str_string = $str_date.'T'.$str_time."+".$timeoffset.":".$dotoffset;
	return $str_string;
}

?>