<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2010 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| xhtml mobile mod by theNoam
| http://www.thenoam.com/
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------+*/
require_once("wap-maincore.php");
// locale begin
if (file_exists(WAP."locale/".$settings['locale'].".php")) {
	include WAP."locale/".$settings['locale'].".php";
} else {
	include WAP."locale/English.php";
}
// locale end

echo("<?xml version=\"1.0\" encoding=\"".$locale['charset']."\"?>\n");
echo("<!DOCTYPE html PUBLIC \"-//WAPFORUM//DTD XHTML Mobile 1.0//EN\""
." \"http://www.wapforum.org/DTD/xhtml-mobile10.dtd\">\n");
echo "
<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang='".$locale['wap004']."'>\n
<head>\n
    <title>".$locale['wap001']."</title>\n
	<meta http-equiv='Content-Type' content='text/html; charset=".$locale['charset']."'/>\n
    <link href='style.css' rel='stylesheet' type='text/css'/>\n
</head>\n";
echo "
<body>\n
<div class='dir'>\n
<table class='wide'>\n
<tr><td><img src='images/banner_wap.gif' class='displayed' alt='".$locale['wap002']."'/></td></tr>\n
<tr><td><div class='center'>".$locale['wap023']."</div></td></tr>\n";

$limit_number = 0;
if (stripslashes($_GET["limit_number"]) != 0) {
$limit_number = stripslashes($_GET["limit_number"]);
}
if ($limit_number < 0) {$limit_number = 0;}

$result=dbquery("SELECT * FROM ".$db_prefix."posts ORDER BY post_datestamp DESC LIMIT ".$limit_number.",5");

while ($row=dbarray($result)) {
	$rsid = intval($row['thread_id']);
	
	$foid = intval($row['forum_id']);	
	$result2 = dbquery("SELECT * FROM ".$db_prefix."forums WHERE forum_id='".$foid."'");
	if (dbrows($result2)) {
	$fdata = dbarray($result2);
	$fcgroup = checkgroup($fdata['forum_access']);
	if ( checkgroup($fdata['forum_access'])==1 ) {
	
	$rtitle = dbresult(dbquery("SELECT thread_subject FROM ".$db_prefix."threads WHERE thread_id='".$row['thread_id']."'"),0);	
	$rdatestamp = $row['post_datestamp'];
	$rauthor = $row['post_author'];
	$forum_name=dbresult(dbquery("SELECT forum_name FROM ".$db_prefix."forums WHERE forum_id='".$row['forum_id']."'"),0);
	$author_name=dbresult(dbquery("SELECT user_name FROM ".$db_prefix."users WHERE user_id='".$rauthor."'"),0);
	$description = stripslashes(nl2br($row['post_message']));
// Add allowable HTML tags below, all others will be stripped
	$description = strip_tags($description, "");
// Parse bbcode into regular text begin
	$description = preg_replace('#\[b\](.*?)\[/b\]#si', '\1', $description);
	$description = preg_replace('#\[i\](.*?)\[/i\]#si', '\1', $description);
	$description = preg_replace('#\[u\](.*?)\[/u\]#si', '\1', $description);
	$description = preg_replace('#\[center\](.*?)\[/center\]#si', '\1', $description);
	$description = preg_replace('#\[url\]([\r\n]*)([^\s\'\";\+]*?)([\r\n]*)\[/url\]#si', 'URL', $description);
	$description = preg_replace('#\[url=([\r\n]*)(http://|ftp://|https://|ftps://)([^\s\'\";\+]*?)\](.*?)([\r\n]*)\[/url\]#si', 'URL', $description);
	$description = preg_replace('#\[url=([\r\n]*)([^\s\'\";\+]*?)\](.*?)([\r\n]*)\[/url\]#si', 'URL', $description);
	$description = preg_replace('#\[mail\]([\r\n]*)([^\s\'\";:\+]*?)([\r\n]*)\[/mail\]#si', 'MAIL', $description);
	$description = preg_replace('#\[mail=([\r\n]*)([^\s\'\";:\+]*?)\](.*?)([\r\n]*)\[/mail\]#si', 'MAIL', $description);
	$description = preg_replace('#\[small\](.*?)\[/small\]#si', '\1', $description);
	$description = preg_replace('#\[color=(black|blue|brown|cyan|gray|green|lime|maroon|navy|olive|orange|purple|red|silver|violet|white|yellow)\](.*?)\[/color\]#si', '\2', $description);
	$description = preg_replace('#\[flash width=([0-9]*?) height=([0-9]*?)\]([^\s\'\";:\+]*?)(\.swf)\[/flash\]#si', ' ', $description);
	$description = preg_replace('#\[img\]((http|ftp|https|ftps)://)(.*?)(\.(jpg|jpeg|gif|png|JPG|JPEG|GIF|PNG))\[/img\]#si','IMG',$description);
// start addition
	$description = preg_replace('@(https?://([-\w\.]+)+(:\d+)?(/([\w/_\.]*(\?\S+)?)?)?)@i', 'URL', $description);
	$description = preg_replace('@(www\.(:\d+)?(/([\w/_\.]*(\?\S+)?)?)?)@i', 'URL', $description);
	$description = preg_replace('@\[code\](.*?)\[/code\]@si', 'CODE', $description);
// end addition	
	$qcount = substr_count($description, "[quote]"); $ccount = substr_count($description, "[code]");
	for ($i=0;$i < $qcount;$i++) $description = preg_replace('#\[quote\](.*?)\[/quote\]#si', '\1', $description);
	for ($i=0;$i < $ccount;$i++) $description = preg_replace('#\[code\](.*?)\[/code\]#si', '\1', $description);
// Parse bbcode into regular text end

echo "<tr><td class='blue2'><small> [ ".$forum_name." ] </small><br /><a href='wap-forums-e.php?thread_id=".$rsid."' style='text-decoration:none; color:#fff;'><b>".htmlspecialchars($rtitle)."</b></a></td></tr>\n";
echo "<tr><td class='blue2'><small> [".$author_name." - ".showdate("%d/%m/%Y %H:%M", $rdatestamp)." ]  </small></td></tr>\n"; 
echo "<tr><td class='blue3'>".$description."</td></tr>\n";
	}
	}
}



$limit_number = $limit_number + 5;

echo "
</table>\n
<p class='center'><a href='wap-forums.php?limit_number=".$limit_number."' class='black'>".$locale['wap101']."</a><br />\n";
if($limit_number > 5){
$limit_number1 = $limit_number - 10;
echo "<a href='wap-forums.php?limit_number=".$limit_number1."' class='black'>".$locale['wap102']."</a><br />\n";
}
echo "<a href='index.php' class='black'>".$locale['wap010']."</a></p>\n
</div>\n
</body>\n
</html>\n";
?>