<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2010 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: wap-members.php
| Author: Nick Jones (Digitanium)
+--------------------------------------------------------+
| Moded for xhtml mobile mod by theNoam
| http://www.thenoam.com/
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once "wap-maincore.php";
include LOCALE.LOCALESET."admin/members.php";
include LOCALE.LOCALESET."user_fields.php";

// locale begin
if (file_exists(WAP."locale/".$settings['locale'].".php")) {
	include WAP."locale/".$settings['locale'].".php";
} else {
	include WAP."locale/English.php";
}
// locale end

if (!checkrights("M") || !defined("iAUTH") || $_GET['aid'] != iAUTH) { redirect("index.php"); }
if (!isset($_GET['step'])) { $_GET['step'] = ""; }

echo("<?xml version=\"1.0\" encoding=\"".$locale['charset']."\"?>\n");
echo("<!DOCTYPE html PUBLIC \"-//WAPFORUM//DTD XHTML Mobile 1.0//EN\""
." \"http://www.wapforum.org/DTD/xhtml-mobile10.dtd\">\n");
echo "
<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang='".$locale['wap004']."'>\n
<head>\n
    <title>".$locale['wap001']."</title>\n
	<meta http-equiv='Content-Type' content='text/html; charset=".$locale['charset']."'>\n
    <link href='style.css' rel='stylesheet' type='text/css'/>\n
</head>\n";
echo "
<body>\n
<div class='dir'>\n
<table class='wide'>\n
<tr><td><img src='images/banner_wap.gif' class='displayed' alt='".$locale['wap002']."' /></td></tr>\n
<tr><td><div class='center'>".$locale['wap071']."</div></td></tr>\n";

	// opentable($locale['400']);
	if ($_GET['step'] == "ban" && isnum($_GET['user_id'])) {
		if ($_GET['act'] == "on") {
			$udata = dbarray(dbquery("SELECT * FROM ".DB_USERS." WHERE user_id='".$_GET['user_id']."'"));
			if ($udata && $udata['user_level'] < 102) {
				$result = dbquery("UPDATE ".DB_USERS." SET user_status='1' WHERE user_id='".$_GET['user_id']."'");
				echo "<div style='text-align:center'>".$locale['420']."<br /><br /></div>\n";
			}
		} elseif ($_GET['act'] == "off") {
			$result = dbquery("UPDATE ".DB_USERS." SET user_status='0' WHERE user_id='".$_GET['user_id']."'");
			echo "<div style='text-align:center'>".$locale['421']."<br /><br /></div>\n";
		}
	} elseif ($_GET['step'] == "activate" && isnum($_GET['user_id'])) {
		$result = dbquery("SELECT user_name,user_email FROM ".DB_USERS." WHERE user_id='".$_GET['user_id']."'");
		if (dbrows($result) != 0) {
			$udata = dbarray($result);
			$result = dbquery("UPDATE ".DB_USERS." SET user_status='0' WHERE user_id='".$_GET['user_id']."'");
			if ($settings['email_verification'] == "1") {
				require_once INCLUDES."sendmail_include.php";
				sendemail($udata['user_name'],$udata['user_email'],$settings['siteusername'],$settings['siteemail'],$locale['425'].$settings['sitename'],str_replace("[USER_NAME]", $udata['user_name'], $locale['426']));
			}
			echo "<div style='text-align:center'>".$locale['424']."<br /><br /></div>\n";
		}
	} elseif ($_GET['step'] == "delete" && isnum($_GET['user_id'])) {
		$udata = dbarray(dbquery("SELECT * FROM ".DB_USERS." WHERE user_id='".$_GET['user_id']."'"));
		if ($udata['user_level'] < 102) {
			$result = dbquery("DELETE FROM ".DB_USERS." WHERE user_id='".$_GET['user_id']."'");
			$result = dbquery("DELETE FROM ".DB_ARTICLES." WHERE article_name='".$_GET['user_id']."'");
			$result = dbquery("DELETE FROM ".DB_COMMENTS." WHERE comment_name='".$_GET['user_id']."'");
			$result = dbquery("DELETE FROM ".DB_MESSAGES." WHERE message_to='".$_GET['user_id']."' OR message_from='".$_GET['user_id']."'");
			$result = dbquery("DELETE FROM ".DB_NEWS." WHERE news_name='".$_GET['user_id']."'");
			$result = dbquery("DELETE FROM ".DB_POLL_VOTES." WHERE vote_user='".$_GET['user_id']."'");
			$result = dbquery("DELETE FROM ".DB_RATINGS." WHERE rating_user='".$_GET['user_id']."'");
			$result = dbquery("DELETE FROM ".DB_SHOUTBOX." WHERE shout_name='".$_GET['user_id']."'");
			$result = dbquery("DELETE FROM ".DB_THREADS." WHERE thread_author='".$_GET['user_id']."'");
			$result = dbquery("DELETE FROM ".DB_POSTS." WHERE post_author='".$_GET['user_id']."'");
			$result = dbquery("DELETE FROM ".DB_THREAD_NOTIFY." WHERE notify_user='".$_GET['user_id']."'");
			echo "<div style='text-align:center'>".$locale['422']."<br /><br /></div>\n";
		}
	}
	if (!isset($_GET['status']) || !isnum($_GET['status'])) { $_GET['status'] = "0"; }
	if (isset($_GET['search_text']) && preg_check("/^[-0-9A-Z_@\s]+$/i", $_GET['search_text'])) {
		$user_name = " user_name LIKE '".stripinput($_GET['search_text'])."%' AND";
		$list_link = "search_text=".stripinput($_GET['search_text']);
	} elseif (isset($_GET['sortby']) && preg_check("/^[0-9A-Z]$/", $_GET['sortby'])) { 
		$user_name = ($_GET['sortby'] == "all" ? "" : " user_name LIKE '".stripinput($_GET['sortby'])."%' AND");
		$list_link = "sortby=".stripinput($_GET['sortby']);
	} else {
		$user_name = "";
		$list_link = "sortby=all";
		$_GET['sortby'] = "all";
	}
	$result = dbquery("SELECT * FROM ".DB_USERS." WHERE".$user_name." user_status='".$_GET['status']."'AND user_level<'102'");
	$rows = dbrows($result);
	if (!isset($_GET['rowstart']) || !isnum($_GET['rowstart'])) $_GET['rowstart'] = 0; 
	$result = dbquery("SELECT * FROM ".DB_USERS." WHERE".$user_name." user_status='".$_GET['status']."'AND user_level<'102' ORDER BY user_status DESC, user_level DESC, user_name LIMIT ".$_GET['rowstart'].",20");
	echo "<tr><td class='blue2'>\n";
	echo "<a href='".FUSION_SELF.$aidlink."&amp;".$list_link."&amp;status=0' class='white'>".$locale['417']."</a> \n";
	echo "</td></tr><tr><td class='blue2'>\n";
	echo "<a href='".FUSION_SELF.$aidlink."&amp;".$list_link."&amp;status=2' class='white'>".$locale['418']."</a> \n";
	echo "</td></tr><tr><td class='blue2'>\n";
	echo "<a href='".FUSION_SELF.$aidlink."&amp;".$list_link."&amp;status=1' class='white'>".$locale['419']."</a> \n";
	echo "</td></tr><tr><td style='font-size:small;'>\n";
	echo "| Act=".$locale['407']." | Del=".$locale['410']." |<br />\n";
	echo "| Ban=".$locale['409']." | UnB=".$locale['408']." |\n";
	echo "</td></tr><br />\n";
	if ($rows) {
		$i = 0;
		echo "<table cellpadding='0' cellspacing='1' width='100%'>\n<tr>\n";
		echo "<td class='blue5'><strong>".$locale['401']."</strong></td>\n";
		echo "<td align='center' width='1%' class='blue5' style='white-space:nowrap'><strong>".$locale['wap072']."</strong></td>\n";
		echo "<td align='center' width='1%' class='blue5' style='white-space:nowrap'><strong>".$locale['404']."</strong></td>\n";
		echo "</tr>\n";
		while ($data = dbarray($result)) {
			$cell_color = ($i % 2 == 0 ? "blue6" : "blue6");
			echo "<tr>\n<td class='$cell_color'>".$data['user_name']."</td>\n";
			echo "<td align='center' width='1%' class='$cell_color' style='white-space:nowrap'>".getuserlevel($data['user_level'])."</td>\n";
			echo "<td align='center' width='1%' class='$cell_color' style='white-space:nowrap'>";
			//if ($data['user_level'] < 102) echo "<a href='".FUSION_SELF.$aidlink."&amp;step=edit&amp;user_id=".$data['user_id']."' class='white'> Edit </a>\n";
			if ($data['user_status'] == "2") {
				echo "<a href='".FUSION_SELF.$aidlink."&amp;step=activate&amp;".$list_link."&amp;status=".$_GET['status']."&amp;rowstart=".$_GET['rowstart']."&amp;user_id=".$data['user_id']."' class='white'> Act </a>\n";
			} elseif ($data['user_status'] == "1") {
				echo "<a href='".FUSION_SELF.$aidlink."&amp;step=ban&amp;act=off&amp;".$list_link."&amp;status=".$_GET['status']."&amp;rowstart=".$_GET['rowstart']."&amp;user_id=".$data['user_id']."' class='white'> UnB </a>\n";
			} else {
				if ($data['user_level'] < 102) echo "<a href='".FUSION_SELF.$aidlink."&amp;step=ban&amp;act=on&amp;".$list_link."&amp;status=".$_GET['status']."&amp;rowstart=".$_GET['rowstart']."&amp;user_id=".$data['user_id']."' class='white'> Ban </a>\n";
			}
			if ($data['user_level'] < 102) echo "<a href='".FUSION_SELF.$aidlink."&amp;step=delete&amp;".$list_link."&amp;status=".$_GET['status']."&amp;rowstart=".$_GET['rowstart']."&amp;user_id=".$data['user_id']."' onclick='return DeleteMember();' class='white'> Del </a>";
			echo "</td>\n</tr>\n"; $i++;
		}
		echo "</table>\n";
	} else {
		if (isset($_GET['status']) && $_GET['status'] == "0") { $user_types = ""; }
		elseif (isset($_GET['status']) && $_GET['status'] == "1") { $user_types = $locale['419']; }
		elseif (isset($_GET['status']) && $_GET['status'] == "2") { $user_types = $locale['418']; }
		
		if (isset($_GET['search_text']) && preg_check("/^[-0-9A-Z_@\s]+$/i", $_GET['search_text'])) {
			echo "<div style='text-align:center'><br />".sprintf($locale['411'], $user_types).$locale['413']."'".stripinput($_GET['search_text'])."'<br /><br />\n</div>\n";
		} else {
			echo "<div style='text-align:center'><br />".sprintf($locale['411'], $user_types).($_GET['sortby'] == "all" ? "" : $locale['412'].$_GET['sortby']).".<br /><br />\n</div>\n";
		}
	}
	$alphanum = array(
		"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R",
		"S","T","U","V","W","X","Y","Z","0","1","2","3","4","5","6","7","8","9"
	);
	echo "<table cellpadding='0' cellspacing='1' width='100%' style='margin-top:10px;'>\n<tr>\n";
	echo "<td class='blue5' style='text-align:center;'><a href='".FUSION_SELF.$aidlink."&amp;sortby=all&amp;status=".$_GET['status']."' class='white'>".$locale['414']."</a></td>";
	echo "</tr>\n</table>\n";
	echo "<table cellpadding='0' cellspacing='1' width='100%'>\n<tr>\n";
	for ($i=0;$i < 36;$i++) {
		echo "<td align='center' class='blue6'><a href='".FUSION_SELF.$aidlink."&amp;sortby=".$alphanum[$i]."&amp;status=".$_GET['status']."' class='white'>".$alphanum[$i]."</a></td>";
		echo ($i==17 ? "</tr>\n<tr>\n" : "\n");
	}
	echo "</tr>\n</table>\n";
	echo "<hr />\n<form name='searchform' method='get' action='".FUSION_SELF."'>\n";
	echo "<div style='text-align:center'>\n";
	echo "<input type='hidden' name='aid' value='".iAUTH."' />\n";
	echo "<input type='hidden' name='status' value='".$_GET['status']."' />\n";
	echo $locale['415']." <input type='text' name='search_text' class='textbox' style='width:150px'/>\n";
	echo "<input type='submit' name='search' value='".$locale['416']."' class='button' />\n";
	echo "</div>\n</form>\n";
	//closetable();
	if ($rows > 20) echo "<div align='center' style='margin-top:5px;'>\n".makepagenav($_GET['rowstart'],20,$rows,3,FUSION_SELF.$aidlink."&amp;".$list_link."&amp;status=".$_GET['status']."&amp;")."\n</div>\n";
	echo "<script type='text/javascript'>"."\n"."function DeleteMember(username) {\n";
	echo "return confirm('".$locale['423']."');\n}\n</script>\n";

echo "
</table>\n
<p class='center'><a href='index.php' class='black'>".$locale['wap010']."</a><br />\n
<a href='wap-login.php' class='black'>".$locale['wap073']."</a>\n
</p>\n
</div>\n
</body>\n
</html>\n";
?>