<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2010 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| xhtml mobile mod by theNoam
| http://www.thenoam.com/
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------+*/
require_once("wap-maincore.php");

if (iMEMBER) {
// locale begin
if (file_exists(WAP."locale/".$settings['locale'].".php")) {
	include WAP."locale/".$settings['locale'].".php";
} else {
	include WAP."locale/English.php";
}
// locale end

echo("<?xml version=\"1.0\" encoding=\"".$locale['charset']."\"?>\n");
echo("<!DOCTYPE html PUBLIC \"-//WAPFORUM//DTD XHTML Mobile 1.0//EN\""
." \"http://www.wapforum.org/DTD/xhtml-mobile10.dtd\">\n");

echo "
<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang='".$locale['wap004']."'>\n
<head>\n
    <title>".$locale['wap001']."</title>\n
	<meta http-equiv='Content-Type' content='text/html; charset=".$locale['charset']."'/>\n
    <link href='style.css' rel='stylesheet' type='text/css'/>\n
</head>\n";
echo "
<body>\n
<div class='dir'>\n
<table class='wide'>\n
<tr><td><img src='images/banner_wap.gif' class='displayed' alt='".$locale['wap002']."' /></td></tr>\n
<tr><td><div class='center'>".$locale['wap017']."</div></td></tr>\n";

if (!defined("IN_FUSION")) { header("Location:../../index.php"); exit; }
$result = dbquery("SELECT * FROM ".$db_prefix."users WHERE user_lastvisit>'0' AND user_status='0' ORDER BY user_lastvisit DESC LIMIT 0,10");
if (dbrows($result) != 0) {
	while ($data = dbarray($result)) {
	$lastseen = time() - $data['user_lastvisit'];
	$iW=sprintf("%2d",floor($lastseen/604800));
	$iD=sprintf("%2d",floor($lastseen/(60*60*24)));
	$iH=sprintf("%02d",floor((($lastseen%604800)%86400)/3600));
	$iM=sprintf("%02d",floor(((($lastseen%604800)%86400)%3600)/60));
	$iS=sprintf("%02d",floor((((($lastseen%604800)%86400)%3600)%60)));
	if ($lastseen < 60){
	$lastseen = $locale['wap041'];
	} elseif ($lastseen < 360){
	$lastseen = $locale['wap042'];
	} elseif ($iW > 0){
	if ($iW == 1) { $text = $locale['wap043']; } else { $text = $locale['wap044']; }
	$lastseen = $iW." ".$text;
	} elseif ($iD > 0){
	if ($iD == 1) { $text = $locale['wap045']; } else { $text = $locale['wap046']; }
	$lastseen = $iD." ".$text;
	} else {
	$lastseen = $iH.":".$iM.":".$iS;
	}
	echo "<tr><td class='blue3'>".$data['user_name']."</td></tr>\n";
	echo "<tr><td class='blue2'><small>".$lastseen."</small></td></tr>\n";
	}
}
// start of user on line code
$result = dbquery("SELECT * FROM ".DB_ONLINE." WHERE online_user=".($userdata['user_level'] != 0 ? "'".$userdata['user_id']."'" : "'0' AND online_ip='".USER_IP."'"));
if (dbrows($result)) {
	$result = dbquery("UPDATE ".DB_ONLINE." SET online_lastactive='".time()."' WHERE online_user=".($userdata['user_level'] != 0 ? "'".$userdata['user_id']."'" : "'0' AND online_ip='".USER_IP."'")."");
} else {
	$result = dbquery("INSERT INTO ".DB_ONLINE." (online_user, online_ip, online_lastactive) VALUES ('".($userdata['user_level'] != 0 ? $userdata['user_id'] : "0")."', '".USER_IP."', '".time()."')");
}
$result = dbquery("DELETE FROM ".DB_ONLINE." WHERE online_lastactive<".(time()-60)."");

$result = dbquery(
	"SELECT ton.*, tu.user_id,user_name FROM ".DB_ONLINE." ton
	LEFT JOIN ".DB_USERS." tu ON ton.online_user=tu.user_id"
);
$guests = 0; $members = array();
while ($data = dbarray($result)) {
	if ($data['online_user'] == "0") {
		$guests++;
	} else {
		array_push($members, array($data['user_id'], $data['user_name']));
	}
}
echo "<tr><td>&nbsp;</td></tr>\n";
echo "<tr><td class='blue3'>".$locale['wap051'].": <small>".$guests."</small></td></tr>\n";
echo "<tr><td class='blue2'>".$locale['wap052'].": <small>".count($members)."</small></td></tr>\n";
if (count($members)) {
	$i = 1;
	while (list($key, $member) = each($members)) {
		//echo "<small>".$member[1]."</small>";
		//if ($i != count($members)) { echo ",\n"; } else { echo "<br />\n"; }
		$i++;
	}
}
echo "<tr><td class='blue3'>".$locale['wap054'].": <small>".number_format(dbcount("(user_id)", DB_USERS, "user_status<='1'"))."</small></td></tr>\n";

$data = dbarray(dbquery("SELECT user_id,user_name FROM ".DB_USERS." WHERE user_status='0' ORDER BY user_joined DESC LIMIT 0,1"));
echo "<tr><td class='blue2'>".$locale['wap056'].": <small>".$data['user_name']."</small></td></tr>\n";

echo "
</table>\n
<p class='center'><a href='index.php' class='black'>".$locale['wap010']."</a></p>\n
</div>\n
</body>\n
</html>\n";
} else { redirect("index.php"); }
?>